import numpy as np
import pandas as pd
import matplotlib.pyplot as plt
import matplotlib
# matplotlib.use('TkAgg')
from pathlib import Path
import h5py
import os
import sfHMM
import warnings
from scipy.ndimage import median_filter

import warnings
from sklearn.exceptions import ConvergenceWarning
warnings.filterwarnings(action='ignore', category=ConvergenceWarning)


def moving_average(x, w):
    return np.convolve(x, np.ones(w)) / w


def moving_average_axs(x, w, axis):
    return np.apply_along_axis(moving_average, axis, x, w=w)


baseDir = Path('M:/tnw/bn/cd/Shared/Tisma/ParB-BsSMC_spt/2023/20230508_hdf5_Lipfert_coil')
dataFolderPlus = baseDir / '(+)coil' / '20ms'
dataFolderMin = baseDir / '(-)coil' / '20ms'


for folder, outputFile in zip([dataFolderMin, dataFolderPlus], ['(-)coil_20ms_TotalIntensity.xlsx', '(+)coil_20ms_TotalIntensity.xlsx']):
    hdf5Files = []
    df = pd.DataFrame()
    for f in folder.iterdir():
        if f.suffix == '.hdf5':
            hdf5Files.append(f)
    print(f'Found {len(hdf5Files)} files to analyse')

    for i, p in enumerate(hdf5Files):
        with h5py.File(p, 'r') as f:
            # for region in ['', ' Loop']:
            kymoLeft = f['Left Kymograph Loop'][()]
            # plt.plot(np.sum(kymoLeft, axis=0))
            df2 = pd.DataFrame()
            df2[str(i)] = np.sum(kymoLeft, axis=0)
        df = pd.concat([df, df2], axis=1)

    df.to_excel(outputFile)
